scala.tools.nsc.ast

# TreeInfo

###
Related Doc: package ast

#### abstract class TreeInfo extends reflect.internal.TreeInfo

This class ...

Source
  TreeInfo.scala
Version

  1.0

Linear Supertypes
reflect.internal.TreeInfo, AnyRef, Any
Known Subclasses
treeInfo
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TreeInfo
2. TreeInfo
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new TreeInfo()

### Type Members

1. #### class Applied extends AnyRef

   Definition Classes
     TreeInfo

2. #### class DynamicApplicationExtractor extends AnyRef

   Definition Classes
     TreeInfo

3. #### abstract class SeeThroughBlocks[T] extends AnyRef

   Definition Classes
     TreeInfo

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     TreeInfo → TreeInfo

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TreeInfo to any2stringadd[TreeInfo] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (TreeInfo, B)

   Implicit information
     This member is added by an implicit conversion from TreeInfo to ArrowAssoc[TreeInfo] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object Applied

   Definition Classes
     TreeInfo

7. #### object AsInstanceOf

8. #### object BinaryOp

9. #### object DynamicApplication extends DynamicApplicationExtractor

   Definition Classes
     TreeInfo

10. #### object DynamicApplicationNamed extends DynamicApplicationExtractor

    Definition Classes
      TreeInfo

11. #### object DynamicUpdate extends DynamicApplicationExtractor

    Definition Classes
      TreeInfo

12. #### object IsFalse extends SeeThroughBlocks[Boolean]

    Definition Classes
      TreeInfo

13. #### object IsTrue extends SeeThroughBlocks[Boolean]

    Definition Classes
      TreeInfo

14. #### object MacroImplReference

    Definition Classes
      TreeInfo

15. #### final val SYNTH_CASE_FLAGS: Int(2099200)

    Definition Classes
      TreeInfo

16. #### object StripCast

    Definition Classes
      TreeInfo

17. #### object TypeApplyOp

18. #### object Unapplied

    Definition Classes
      TreeInfo

19. #### object ValueClass

20. #### object WildcardStarArg

    Definition Classes
      TreeInfo

21. #### def admitsTypeSelection(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

22. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

23. #### def assignmentToMaybeNamedArg(tree: Global.Tree): Global.Tree

    Definition Classes
      TreeInfo

24. #### def catchesThrowable(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

25. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

26. #### def dissectApplied(tree: Global.Tree): Applied

    Definition Classes
      TreeInfo

27. #### def effectivePatternArity(args: List[Global.Tree]): Int

    Definition Classes
      TreeInfo

28. #### def ensuring(cond: (TreeInfo) ⇒ Boolean, msg: ⇒ Any): TreeInfo

    Implicit information
      This member is added by an implicit conversion from TreeInfo to Ensuring[TreeInfo] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

29. #### def ensuring(cond: (TreeInfo) ⇒ Boolean): TreeInfo

    Implicit information
      This member is added by an implicit conversion from TreeInfo to Ensuring[TreeInfo] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

30. #### def ensuring(cond: Boolean, msg: ⇒ Any): TreeInfo

    Implicit information
      This member is added by an implicit conversion from TreeInfo to Ensuring[TreeInfo] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

31. #### def ensuring(cond: Boolean): TreeInfo

    Implicit information
      This member is added by an implicit conversion from TreeInfo to Ensuring[TreeInfo] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

32. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

33. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

34. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

35. #### def firstConstructor(stats: List[Global.Tree]): Global.Tree

    Definition Classes
      TreeInfo

36. #### def firstConstructorArgs(stats: List[Global.Tree]): List[Global.Tree]

    Definition Classes
      TreeInfo

37. #### def firstDefinesClassOrObject(trees: List[Global.Tree], name: Global.Name): Boolean

    Definition Classes
      TreeInfo

38. #### def flattenedPatternArgs(args: List[Global.Tree]): List[Global.Tree]

    Definition Classes
      TreeInfo

39. #### def foreachMethodParamAndArg(params: List[Global.Symbol], args: List[Global.Tree])(f: (Global.Symbol, Global.Tree) ⇒ Unit): Boolean

    Definition Classes
      TreeInfo

40. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from TreeInfo to StringFormat[TreeInfo] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

41. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

42. #### def hasSynthCaseSymbol(t: Global.Tree): Boolean

    Definition Classes
      TreeInfo

43. #### def hasUntypedPreSuperFields(stats: List[Global.Tree]): Boolean

    Definition Classes
      TreeInfo

44. #### def hasVolatileType(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

45. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

46. #### def isAbsTypeDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

47. #### def isAliasTypeDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

48. #### def isApplyDynamicName(name: Global.Name): Boolean

    Definition Classes
      TreeInfo

49. #### def isByNameParamType(tpt: Global.Tree): Boolean

    Definition Classes
      TreeInfo

50. #### def isCatchCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

51. #### def isConstructorWithDefault(t: Global.Tree): Boolean

    Definition Classes
      TreeInfo → TreeInfo

52. #### def isDeclarationOrTypeDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

53. #### def isDefaultCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

54. #### def isDefaultGetter(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

55. #### def isEarlyDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

56. #### def isEarlyValDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

57. #### def isExprSafeToInline(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

58. #### def isGuardedCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

59. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

60. #### def isInterfaceMember(tree: Global.Tree): Boolean

    Is tree legal as a member definition of an interface?

    Is tree legal as a member definition of an interface?

    Definition Classes
      TreeInfo → TreeInfo

61. #### def isLeftAssoc(operator: Global.Name): Boolean

    Definition Classes
      TreeInfo

62. #### def isMacroApplication(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

63. #### def isMacroApplicationOrBlock(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

64. #### def isNullaryInvocation(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

65. #### def isPath(tree: Global.Tree, allowVolatile: Boolean): Boolean

    Definition Classes
      TreeInfo

66. #### def isPureDef(tree: Global.Tree): Boolean

    Is tree a pure (i.e.

    Is tree a pure (i.e. non-side-effecting) definition?

    Definition Classes
      TreeInfo → TreeInfo

67. #### def isPureExprForWarningPurposes(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

68. #### def isQualifierSafeToElide(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

69. #### def isRepeatedParamType(tpt: Global.Tree): Boolean

    Definition Classes
      TreeInfo

70. #### def isSelfConstrCall(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

71. #### def isSelfOrSuperConstrCall(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

72. #### def isSequenceValued(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

73. #### def isStableIdentifier(tree: Global.Tree, allowVolatile: Boolean): Boolean

    Definition Classes
      TreeInfo

74. #### def isStableIdentifierPattern(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

75. #### def isStableMemberOf(sym: Global.Symbol, tree: Global.Tree, allowVolatile: Boolean): Boolean

    Definition Classes
      TreeInfo

76. #### def isStar(x: Global.Tree): Boolean

    Definition Classes
      TreeInfo

77. #### def isSuperConstrCall(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

78. #### def isSwitchAnnotation(tpe: Global.Type): Boolean

    Definition Classes
      TreeInfo

79. #### def isSynthCaseSymbol(sym: Global.Symbol): Boolean

    Definition Classes
      TreeInfo

80. #### def isSyntheticCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

81. #### def isSyntheticDefaultCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

82. #### def isTraitRef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

83. #### def isVarPattern(pat: Global.Tree): Boolean

    Definition Classes
      TreeInfo

84. #### def isVarPatternDeep(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

85. #### def isVariableOrGetter(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

86. #### def isWildcardArg(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

87. #### def isWildcardStarArg(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

88. #### def isWildcardStarArgList(trees: List[Global.Tree]): Boolean

    Definition Classes
      TreeInfo

89. #### def isWildcardStarType(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

90. #### def mapMethodParamsAndArgs[R](params: List[Global.Symbol], args: List[Global.Tree])(f: (Global.Symbol, Global.Tree) ⇒ R): List[R]

    Definition Classes
      TreeInfo

91. #### def mayBeTypePat(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

92. #### def mayBeVarGetter(sym: Global.Symbol): Boolean

    Definition Classes
      TreeInfo

93. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

94. #### def noPredefImportForUnit(body: Global.Tree): Boolean

    Definition Classes
      TreeInfo

95. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

96. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

97. #### def preSuperFields(stats: List[Global.Tree]): List[Global.ValDef]

    Definition Classes
      TreeInfo

98. #### def stripCast(tree: Global.Tree): Global.Tree

    Definition Classes
      TreeInfo

99. #### def stripNamedApplyBlock(tree: Global.Tree): Global.Tree

    Definition Classes
      TreeInfo

100. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

101. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       AnyRef → Any

102. #### def typeParameters(tree: Global.Tree): List[Global.TypeDef]

     Definition Classes
       TreeInfo

103. #### def unbind(x: Global.Tree): Global.Tree

     Definition Classes
       TreeInfo

104. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

105. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

106. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

107. #### def →[B](y: B): (TreeInfo, B)

     Implicit information
       This member is added by an implicit conversion from TreeInfo to ArrowAssoc[TreeInfo] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Inherited from reflect.internal.TreeInfo

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TreeInfo to any2stringadd[TreeInfo]

### Inherited by implicit conversion StringFormat from TreeInfo to StringFormat[TreeInfo]

### Inherited by implicit conversion Ensuring from TreeInfo to Ensuring[TreeInfo]

### Inherited by implicit conversion ArrowAssoc from TreeInfo to ArrowAssoc[TreeInfo]

### Ungrouped